/* This file is part of Indico.
 * Copyright (C) 2002 - 2015 European Organization for Nuclear Research (CERN).
 *
 * Indico is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 3 of the
 * License, or (at your option) any later version.
 *
 * Indico is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Indico; if not, see <http://www.gnu.org/licenses/>.
 */

 @import "partials/toolbars";

%text-input {
    @extend %font-size-body;
    @include border-all();
    @include box-sizing(border-box);
    @include single-transition(border-color);

    font-family: inherit;
    padding: 0 4px;

    &:hover,
    &:focus {
        box-shadow: 1px 1px 4px rgba(20, 20, 20, 0.1) inset;
    }

    &:focus {
        @include border-all($blue);
        outline: none;
    }

    &.hasError {
        @include border-all($red);
        background-color: $light-red;
    }
}

input[type=text],
input[type=email],
input[type=number],
input[type=password],
input[type=search],
input[type=time] {
    @extend %text-input;

    height: 1.6em;
    -webkit-appearance: textfield;

    &.placeholder {
        color: #aaa;
    }
}

input[type=file] {
    &.hasError {
        @include border-all($red);
        color: $red;
        background: $light-red;
    }
}

input[type=checkbox].validate {
    &:not(:checked) + label {
        @extend .text-error;
    }
}

input[type=number], input[type=time] {
    -moz-appearance: textfield;
    padding-right: 0;

    &::-webkit-inner-spin-button {
        cursor: pointer;
        margin-left: 4px;
        position: relative;
    }
}

textarea {
    @extend %text-input;
}

select {
    &.hasError {
        @include border-all($red);
        color: $red;
    }
}

div[contenteditable],
span[contenteditable] {
    p {
        margin: 0px;
    }

    &:hover {
        outline: 1px dashed $gray;
    }

    &:focus,
    &.focus {
        background: white;
        box-shadow: 1px 1px 4px rgba(20, 20, 20, 0.1) inset;
        outline: 1px solid $blue;
    }

    &.empty {
        color: $gray;
        font-style: italic;
    }
}

.i-selection {
    input[type=checkbox],
    input[type=radio] {
        display: none;

        &:checked + label,
        &:checked:not(:disabled) + label:hover {
            @include gradient(#387EE5, #5D95EA);
            box-shadow: 1px 1px 4px rgba(20, 20, 20, 0.1) inset;
            color: white !important;
        }

        &:first-child + label {
            @include border-left-radius();
        }

        &:disabled + label.i-button {
            @extend %button-disabled;
        }
    }

    input[type=radio] {
        &:checked + label:hover {
            cursor: default !important;
        }
    }

    label {
        &:hover {
            @include gradient(#E2E2E2, #F7F7F7);
            border-color: $gray !important;
            box-shadow: 1px 1px 4px rgba(20, 20, 20, 0.1) inset;
        }

        &:active {
            @include gradient(#81ADEF, #A5C4F3);
        }
    }
}

.checkbox-with-text {
    input[type=checkbox] {
        float: left;
        margin-left: 1px;
    }

    div {
        margin-left: 21px;
    }
}


// Toggle Switch
$switch-transition-step: 0.05s;
$switch-label-transition: $switch-transition-step ease-out;
$switch-handle-transition: 2*$switch-transition-step ease-out;
$switch-shadow-color: lighten($light-black, $color-variation);
$switch-shadow-border: inset 0 0 0 0.08em;
$switch-shadow-blur: 0.16em;
$switch-left-shadow: -(0.05em + $switch-shadow-blur) 0 $switch-shadow-blur -$switch-shadow-blur $switch-shadow-color;
$switch-right-shadow: 0.05em + $switch-shadow-blur 0 $switch-shadow-blur -$switch-shadow-blur $switch-shadow-color;
$switch-inner-shadow: inset 0 0 0.4em $switch-shadow-color;
%switch-elem {
    position: relative;
    z-index: 100;

    display: inline-block;
    width: 50%;
    height: 100%;

    text-align: center;
    text-transform: uppercase;
    line-height: 2;
    font-size: 0.8em;
    font-weight: normal;
}
%switch-elem-visible {
    visibility: visible;
    opacity: 1.0;
    @include transition(visibility $switch-label-transition 3*$switch-transition-step,
                                opacity $switch-label-transition 2*$switch-transition-step);
}
%switch-elem-hidden {
    visibility: hidden;
    opacity: 0.0;
    @include transition(visibility $switch-label-transition 1*$switch-transition-step,
                                opacity $switch-label-transition 0*$switch-transition-step);
}
.switch {
    position: relative;

    display: inline-block;
    width: 6em;
    height: 1.6em;

    @include border-radius();
    background-color: lighten($dark-gray, $color-variation);
    box-shadow: $switch-shadow-border $dark-gray, $switch-inner-shadow;
    @include user-select(none);

    & > .switch-label {
        position: absolute;
        top: 0;
        bottom: 0;
        left: 0;
        right: 0;

        cursor: pointer;

        &:before {
            @extend %switch-elem;
            @extend %switch-elem-visible;

            color: $light-black;
            content: attr(data-off);
        }
        &:after {
            @extend %switch-elem;
            @extend %switch-elem-hidden;

            color: $light-blue;
            content: attr(data-on);
        }
    }
    & > .switch-handle {
        position: absolute;
        top: 0;
        bottom: 0;
        left: 0;
        z-index: 99;

        display: inline-block;
        width: 50%;
        height: 100%;
        @include border-radius();

        background: #EAEAEA;
        box-shadow: $switch-shadow-border $gray, $switch-right-shadow;

        @include transition(left $switch-handle-transition 1*$switch-transition-step,
                            background $switch-handle-transition 1*$switch-transition-step,
                            box-shadow $switch-handle-transition 1*$switch-transition-step);
        cursor: pointer;

    }

    input {
        position: absolute;
        top: 0;
        left: -1000em;
        display: block;
        opacity: 0;

        &:checked {
            & + .switch-label {
                &:before { @extend %switch-elem-hidden; }
                &:after { @extend %switch-elem-visible; }

                & + .switch-handle {
                    left: 50%;

                    background-color: $blue;
                    box-shadow: $switch-shadow-border $dark-blue, $switch-left-shadow;
                 }
            }
        }

        &:disabled {
            & + .switch-label {
                cursor: default;

                &:before, &:after { color: $gray; }
            }
            & + .switch-label + .switch-handle {
                    background-color: #EAEAEA;
                    box-shadow: $switch-shadow-border $gray, $switch-right-shadow;
                    cursor: default;
            }
            &:checked + .switch-label + .switch-handle { box-shadow: $switch-shadow-border $gray, $switch-left-shadow; }
        }

        &:not(:disabled) {
            & + .switch-label:hover + .switch-handle {
                background: #E2E2E2;
                @include gradient(#F7F7F7, #E2E2E2);
            }

            &:checked + .switch-label:hover + .switch-handle {
                background: darken($blue, $color-variation);
                @include gradient($blue, darken($blue, $color-variation));
            }
        }
    }
}

$dropdown-transition-step: 0.05s;
$dropdown-transition: $dropdown-transition-step ease-out;

%dropdown-visible {
    visibility: visible;
    opacity: 1.0;
    @include transition(visibility $dropdown-transition,
                        opacity $dropdown-transition,
                        height $dropdown-transition,
                        padding $dropdown-transition);
}

%dropdown-hidden {
    visibility: hidden;
    opacity: 0.0;
    height: 0 !important;
    padding: 0 !important;
    @include transition(visibility $dropdown-transition,
                        opacity $dropdown-transition,
                        height $dropdown-transition,
                        padding $dropdown-transition);
}

.i-form {
    @extend %font-family-form;
    @include box-sizing(border-box);
    max-width: 800px;
    display: block;
    font-size: 1em;
    color: $light-black;
    margin-top: 1em;

    *, *:before, *:after {
        @include box-sizing(inherit);
    }

    &.management-area {
        padding-top: 1em;
        @include box-shadow(0 2px 1px -1px $pastel-gray);
        border: 1px solid $pastel-gray;
        background-color: $light-gray;
    }

    .form-group {
        clear: both;
        display: inline-block;
        width: 100%;

        .form-block {
            padding-left: 1em;
            padding-right: 1em;
            margin-bottom: 0.7em;

            > .i-linking {
                width: 400px;
                > label {
                    width: 28%;
                    padding: 0.7em 0;
                }
                > .i-linking-dropdown,
                > span.static-text {
                    display: inline-block !important;
                    width: 65% !important;
                }
                > .i-linking-dropdown > select { width: 100%; }

                > input:checked + label {
                    + .i-linking-dropdown,
                    + span {
                        @extend %dropdown-visible;
                    }
                }

                > input:not(:checked) + label {
                    + .i-linking-dropdown,
                    + span {
                        @extend %dropdown-hidden;
                    }
                }
            }
        }

        .form-label {
            margin-top: 0;
            margin-bottom: 0;
            display: inline-block;
            min-height: 2.5em;
            line-height: 1.5;
            position: relative;
        }

        .form-label-middle {
            padding-top: 0.5em;

            .required {
                top: 0.4em;
            }
        }

        .form-label-empty {
            height: 1px;
        }

        .form-field {
            > .form-row,
            > textarea,
            > select,
            > input:not(.i-button):not([type="checkbox"]):not([type="radio"]) {
                width: 400px;
            }

            textarea, select, input:not(.i-button):not([type="checkbox"]):not([type="radio"]) {
                @include border-radius();
                height: 2.5em;
                padding: 0.5em 1em;
                line-height: 1.5;
                color: $black;
                border: 1px solid $gray;
                @include transition-property(border-color, box-shadow);
                @include transition-duration(0.12s, 0.12s);
                @include transition-timing-function(ease-in-out, ease-in-out);
            }

            .i-has-action > input {
                @include border-top-right-radius(0 !important);
                @include border-bottom-right-radius(0 !important);
            }

            > .form-row.i-has-action > input {
                width: 10em;
            }

            > .form-row.i-has-action.i-synced-input {
                padding-right: 0;

                > textarea,
                > input {
                   width: 90%;
                }

                > .i-button {
                    width: 10%;
                }
            }

            input[type="checkbox"],
            input[type="radio"] {
                margin: 0;
                vertical-align: middle;
            }

            input[type=number], input[type=time] {
                padding-right: 0 !important;

                &::-webkit-inner-spin-button {
                    height: 2.3em;
                    margin-left: 1em;
                    margin-top: -0.5em;
                }
            }

            button {
                height: 2.5em;
                vertical-align: top;
            }

            input.table-input {
                width: 100% !important;
            }

            textarea {
                height: auto;
                resize: vertical;
            }

            select {
                background-color: white;
                padding-left: 0;

                &:-moz-focusring {
                    color: transparent;
                    text-shadow: 0 0 0 #000;
                }
            }

            .static-text {
                display: block;
                height: 2.5em;
                padding: 0.5em 1em 0.5em 0;
                line-height: 1.5;
                color: $black;
                width: 400px;
            }

            :invalid {
                box-shadow: none !important;
            }

            .hasDatepicker {
                margin: 0;
                padding-right: 26px !important;
            }

            .ui-datepicker-trigger {
                right: 24px;
            }
        }

        &.horizontal {
            .form-label {
                float: left;
                text-align: right;
                width: 20%;
            }

            .form-field {
                float: left;
                width: 80%;
            }
        }

        &.vertical {
            .form-label {
                float: none;
                text-align: left;
            }

            .form-field {
                width: 100%;
                margin-top: 0;
            }
        }

        &.has-error {
            .form-label, .form-field-error {
                color: $red;
            }

            .form-field {
                & > input, & > select, & > textarea, .i-table-widget {
                    border-color: $red !important;
                }
            }
        }

        .form-field-description {
            margin-top: 0.25em;
            width: 400px;
        }

        .checkbox-label {
            display: inline-block;
            margin-left: 0.5em;
            position: relative;
            bottom: 1px;
            vertical-align: middle;
        }
    }

    &.horizontal {
        .form-label {
            float: left;
            text-align: right;
            width: 20%;
        }

        .form-field {
            float: left;
            width: 80%;
        }
    }

    &.vertical {
        .form-label {
            float: none;
            height: 1em;
            margin-bottom: -1em;
            text-align: left;
        }

        .form-label-empty {
            height: 1px;
            margin-top: 0;
        }

        .form-field {
            width: 100%;
            margin-top: 0.4em;
        }

        .form-group-footer .form-label {
            display: none;
        }
    }

    // Override CKEditor's width so it matches
    // the rest of the form fields.
    .cke {
        width: 100% !important;
    }

    .i-form-button {
        margin: 0.5em 0;
    }

    fieldset {
        border: 0;
        margin-bottom: 1em;
        border-radius: 0.2em;

        legend {
            font-weight: bold;
            font-size: 1.3em;
            border-bottom: 1px solid #ebebeb;
            width: 100%;
            padding-bottom: 0.5em;
            margin-bottom: 0.3em;
        }

        p.description {
            margin: 0.2em 0 0 0;
            font-size: 1.1em;
            padding-left: 2px; // align it with the legend
            color: $dark-gray;
        }

        .form-group:first-of-type {
            margin-top: 2em;
        }

        & + .form-group-footer {
            margin-top: -1em;
        }
    }

    &.no-block-padding {
        .form-block {
            padding-left: 0;
        }
    }
}

/* inspired by https://github.com/brianreavis/selectize.js/blob/master/examples/github.html */
.selectize-control {
    &:before {
        @include transition(opacity 0.2s);
        content: ' ';
        z-index: 2;
        position: absolute;
        display: block;
        top: 1.2em;
        right: 2.4em;
        width: 1.2em;
        height: 1.2em;
        background: url(/images/loading.gif);
        background-size: 1.2em 1.2em;
        opacity: 0;
        visibility: hidden;
    }
    &.loading:before {
        opacity: 0.4;
        visibility: visible;
    }
}

.timedelta-widget {
    input[type=number] {
        display: inline;
        width: 6em;
    }

    select {
        display: inline;
        width: auto;
    }
}

.has-warning {
    color: $yellow;
}

.i-radio, .i-checkbox {
    white-space: nowrap;
    label {
        display: inline-block;
        margin-left: 0.5em;
        position: relative;
        bottom: 1px;
    }
}

.required {
    position: absolute;
    right: 0.1em;
    color: #af0000;
    font-size: 1.4em;
    top: 0.03em;
}

.i-select-box {
    @include border-radius();
    display: block;
    height: 2.5em;
    line-height: 1.5;
    color: $black;
    border: 1px solid $gray;
    @include transition-property(border-color, box-shadow);
    @include transition-duration(0.12s, 0.12s);
    @include transition-timing-function(ease-in-out, ease-in-out);
    width: 400px;
    background-color: white;
    padding: 0.5em 1em 0.5em 0;

    &:-moz-focusring {
        color: transparent;
        text-shadow: 0 0 0 #000;
    }
}

.i-has-action {
    @extend %toolbar-group;
    position: relative;
    > input {
        display: inline-block;
    }

    > textarea {
        @include border-top-right-radius(0 !important);
    }


    > textarea, > input, > .i-button {
        height: 2.5em;
        vertical-align: middle;
        line-height: 1.2em;
        margin: 0;
        padding: 0 0.8em;
    }

    > textarea + .i-button {
        position: absolute;
        top: 0;
        border-left: 0;
    }


    +  .i-has-action-message {
        display: inline-block;
        visibility: hidden;
        opacity: 0;
        height: 1em;
        vertical-align: middle;
    }
}

.i-has-action.i-synced-input {
    > input[type=checkbox] {
        position: absolute;
        top: 0;
        left: 0;
        display: none;
        opacity: 0;
    }
    > label.i-synced-label {
        text-align: center;
        line-height: 2.3em;
    }

    > input[type=checkbox]:not(:checked) ~ .i-synced-label:before { color: $light-black; }
    > input[type=checkbox]:checked ~ .i-synced-label:before { color: $blue; }

    > input[type=text], textarea {
        &[readonly] {
            background-color: lighten($pastel-gray, $light-color-variation);
            background: repeating-linear-gradient(
                -40deg,
                lighten($pastel-gray, 0.5*$color-variation),
                lighten($pastel-gray, 0.5*$color-variation) 10px,
                lighten($pastel-gray, 0.7*$color-variation) 10px,
                lighten($pastel-gray, 0.7*$color-variation) 20px
            );
            font-style: italic;
            color: $dark-gray !important;
        }
    }
}

dd > .i-has-action {
    vertical-align: middle;
    > .i-button, > input {
        height: 2em;
        font-size: 90%;
    }
    > input {
        width: 18em;
        background-color: white;
    }
}

.qtip-content dl > dd > .i-has-action {
    > * {
        line-height: 1em;
    }
    > input {
        width: 110px;
    }
}


.PluginOptionPeopleListDiv.disabled {
    background-color: lighten($pastel-gray, $light-color-variation);
    background: repeating-linear-gradient(
        -40deg,
        lighten($pastel-gray, 0.5*$color-variation),
        lighten($pastel-gray, 0.5*$color-variation) 10px,
        lighten($pastel-gray, 0.7*$color-variation) 10px,
        lighten($pastel-gray, 0.7*$color-variation) 20px
    );
    font-style: italic;
    color: $dark-gray !important;
    pointer-events: none;

    .actions { display: none; }
}
